{% extends "lab_remoto/index.html" %}

{% load staticfiles %}
{% load crispy_forms_tags %}


{% block bibliotecas %}
    <link rel="stylesheet" type="text/css" href="{% static 'choosen/chosen_v1.8.7/chosen.min.css' %}">
    <script type="text/javascript" charset="utf8"
            src="{% static 'choosen/chosen_v1.8.7/chosen.jquery.min.js' %}"></script>
    <script type="text/javascript" src="{% static "ckeditor/ckeditor-init.js" %}"></script>
    <script type="text/javascript" src="{% static "ckeditor/ckeditor/ckeditor.js" %}"></script>

    <script src="https://pagecdn.io/lib/ace/1.4.12/ace.js" crossorigin="anonymous" integrity="sha256-Q9hnBpgBFstzZOr+OKFOWZWfcF5nFXO8Qz48Nmndo6U=" ></script>
{% endblock %}


{% block barra_horizontal %}
    <li>
        <input type="submit"
               form="formulario_conf_ensaio"
               role="button"
               class="btn btn-primary botao-barra-horizontal"
               value="Salvar"
               name="apenas_salvar"
        >

        <input type="submit"
               form="formulario_conf_ensaio"
               role="button"
               class="btn btn-info botao-barra-horizontal"
               value="Salvar e adicionar parâmetro"
               name="salvar_e_criar_novo_parametro"
        >
    </li>

    {#    <li>#}
    {#        <a href="{% url 'educacao:ver_aula' form.instance.aula.id %}" class="btn btn-warning">Voltar</a>#}
    {#    </li>#}
{% endblock %}


{% block corpo_pagina %}
    <div class="card cartao">
        <h5 class="card-header cartao-titulo">
            <img src="{% static 'icones/equipamento.svg' %}">
            Editar Ensaio
        </h5>
        <div class="card-body">
            <form method="post" id="formulario_conf_ensaio" enctype="multipart/form-data"
                  class="formulario sem-asterisco">
                {% csrf_token %}

                <div class="card cartao">
                    <h5 class="card-header">
                        Sobre o ensaio
                    </h5>
                    <div class="card-body">
                        <div class="form-row">
                            <div class="form-group col-md-6 mb-0">
                                {{ formulario.nome|as_crispy_field }}
                            </div>
                            <div class="form-group col-md-6 mb-0">
                                {{ formulario.kit|as_crispy_field }}
                            </div>
                        </div>
                        <div class="form-row">
                            <div class="form-inline col-md-6 mb-0">
                                <div class="form-check">
                                    <div class="form-check-input">{{ formulario.agendavel|as_crispy_field }}</div>
                                    <div class="form-check-label">Os estudantes podem criar execuções?</div>
                                </div>
                            </div>
                            <div class="form-inline col-md-6 mb-0">
                                <div class="form-check">
                                    <div class="form-check-input">{{ formulario.executavel|as_crispy_field }}</div>
                                    <div class="form-check-label">Os estudantes podem agendar/executar ensaios?</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>


                <div class="card cartao">
                    <h5 class="card-header">
                        Parâmetros do kit
                    </h5>
                    <div class="card-body">
                        <p>
                            Esses parâmetros são substituídos no código. Para utilizá-los insira a seguinte notação
                            no código: ${sigla} e então esse texto será substituído pelo valor.
                        </p>
                        <p>
                            Exemplo: suponha que Kenc é um parâmetro do sistema que representa o ganho do encoder e
                            vale 3,1415. Para utilizá-lo no código faça:
                        </p>
                        <p>
                            ganho_encoder = ${Kenc}
                        </p>


                        {% for parametro in parametros_kit %}
                        <ul class="list-group list-group-horizontal-xl">
                            <li class="list-group-item"><b>Nome:</b> {{ parametro.nome }}</li>
                            <li class="list-group-item"><b>Sigla:</b> {{ parametro.sigla }}</li>
                            <li class="list-group-item"><b>Valor:</b> {{ parametro.valor }} {{ parametro.unidade }}</li>
                        </ul>
                       {% endfor %}
                    </div>
                </div>

                <div class="card cartao">
                    <h5 class="card-header">
                        Código do ensaio
                    </h5>
                    <div class="card-body">
                        Instruções:

                        <ul>
                            <li>A placa biblioteca da placa será carregada automaticamente</li>
                            <li>
                                A comunicação com a placa é iniciada automaticamente, sendo criado um objeto chamado
                                "placa"
                            </li>
                            <li>
                                Será criado um dicionário com nome "dados" para armazenar as variáveis que devem ser
                                salvas no arquivo matlab. Desse modo você só precisa preencher o dicionário
                            </li>
                            <li>
                                O arquivo matlab é salvo automaticamente ao final do ensaio, não sendo necessário
                                criar esse arquivo
                            </li>
                            <li>
                                A comunicação com a placa é automaticamente encerrada ao final do ensaio
                            </li>
                        </ul>

                        <div class="form-row">
                            <div class="form-group col-md-12 mb-0" id="editor_codigo">
                                {{ formulario.codigo_executavel|as_crispy_field }}
                            </div>
                        </div>
                    </div>
                </div>


                <div class="card cartao">
                    <h5 class="card-header">
                        Código para geração do gráfico
                    </h5>
                    <div class="card-body">
                        Instruções:

                        <ul>
                            <li></li>
                        </ul>

                        <div class="form-row">
                            <div class="form-group col-md-12 mb-0">
                                {{ formulario.codigo_grafico|as_crispy_field }}
                            </div>
                        </div>
                    </div>
                </div>


                <div class="card cartao">
                    <h5 class="card-header">
                        Parâmetros a serem informados pelos estudates
                    </h5>
                    <div class="card-body">
                        {{ formset.management_form }}
                        {% for form in formset %}
                            <div class="form-group form-row">
                                <div class="col-md-4">
                                    {{ form.nome|as_crispy_field }}
                                </div>
                                <div class="col-md-3">
                                    {{ form.sigla|as_crispy_field }}
                                </div>
                                <div class="col-md-2">
                                    {{ form.valor_minimo|as_crispy_field }}
                                </div>
                                <div class="col-md-2">
                                    {{ form.valor_maximo|as_crispy_field }}
                                </div>

                                {% if form.instance.pode_ser_removido %}
                                <div class="form-check col-md-1">
                                    <a class="btn btn-danger" style="width: 40px; margin-top: 32px" href="{% url 'lab_remoto:remover_parametro' form.instance.id %}" role="button">
                                        X
                                    </a>
                                </div>
                                {% endif %}

                                <div class="row spacer"></div>

                                {% for hidden in form.hidden_fields %}
                                    {{ hidden }}
                                {% endfor %}
                            </div>
                        {% endfor %}
                    </div>
                </div>


            </form>
        </div>
    </div>


{% endblock %}




{% block javascript %}
    $(document).ready(function(){

		 $('textarea').each(function (i, el) {
			var $el = $(el);

			var $container = $('<div/>').css({
                    position: 'relative',
                    height: 600,
                }).insertAfter(el);

			$el.hide();

			var editor = ace.edit($container[0]);
			editor.setTheme('ace/theme/chrome');
			editor.getSession().setMode("ace/mode/python");
			editor.getSession().setValue($el.val());

            editor.setOptions({
                fontSize: "14pt",
            });

			editor.getSession().on('change', function () {
                    $el.val(editor.getSession().getValue());

                });

			editor.getSession().setUseWrapMode(true);

		 });
    });

{% endblock %}

